/*  Time-stamp: <2005-05-27 17:16:52 >  */
#ifndef _4RU_H
#define _4RU_H

#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>
#include  <sys/time.h>
#include  <limits.h>
#include  <unistd.h>
#include  "NOTEfile.h"
#include  "disp_ctr.h"
#include  "xml2note.h"
#include  "ext_chk.h"
#include  "SMFrw.h"
#include  "exist_chk.h"
#ifndef stricmp
#include  "stricmp.h"
#endif

#include  "disp_errline.h"
#include  "eq.h"
#include  "koko.h"
#include  "chain_chk.h"
#include  "og.h"
#include  "get_today.h"
#include  "strrev.h"
#include  "dir_filelist.h"
#include  "enter_fname.h"
#include  "get_cmd_name.h"
#include  "normal_dist.h"


#define  _4RuVER  "0.32"
#define  GENCHANVER  "0.1"

#define  VIEWDEVI   0
#define  VIEWNODEVI 1
#define  VIEWSCORE  2
#define  VIEWNOTE   3

#define  VIEW_ALPHA   0.1


/*  #define  DEFAULT_WIN_WIDTH 1280  */
#define  DEFAULT_WIN_WIDTH 1024
#define  DEFAULT_WIN_HEIGHT 768

#define  DEFAULT_CAMERA_X 0
#define  DEFAULT_CAMERA_Y 0
#define  DEFAULT_CAMERA_Z DEFAULT_WIN_WIDTH

#define  SCOREDISP_MENU 1
#define  DEVIDISP_MENU 2
#define  DISP_VEL_MENU 3
#define  LOUD_MENU 4
#define  NOTE_HEAD_MENU 5
#define  DISP_EVENT_MENU 6
#define  SCROLL_MENU 7
#define  PLAY_MENU 8
#define  GPR_MENU 9
#define  SMF_OUT_MENU 10
#define  NOTE_OUT_MENU 11
#define  XML_OUT_MENU 12
#define  EXP_MENU 13
#define  EXIT_MENU 14


#define  SCOREDISP_ON_STR  "[S] Regularized note"
#define  SCOREDISP_OFF_STR "[S] Real Performance"

#define  DEVIDISP_ON_STR   "[D] Deviation display  On"
#define  DEVIDISP_OFF_STR  "[D] Deviation display  Off"

#define  DISP_VEL_ON_STR   "[V] Velocity value display  On"
#define  DISP_VEL_OFF_STR  "[V] Velocity value display  Off"

#define  LOUD_ON_STR   "[L] Loudness slope display mode  On"
#define  LOUD_OFF_STR  "[L] Loudness slope display mode  Off"

#define  NOTE_HEAD_ON_STR   "[H] Note head display mode   On"
#define  NOTE_HEAD_OFF_STR  "[H] Note head display mode   Off"

#define  DISP_EVENT_ON_STR   "[J] Event display mode   On"
#define  DISP_EVENT_OFF_STR  "[J] Event display mode   Off"

#define  SCROLL_ON_STR   "[C] Scroll Play   On"
#define  SCROLL_OFF_STR  "[C] Scroll Play   Off"

#define  PLAY_STR   "[P] Play"

#define  GPR_ON_STR   "[G] GPR On"
#define  GPR_OFF_STR   "[G] GPR Off"
#define  SMF_OUT_STR   "[M] Output SMF"
#define  NOTE_OUT_STR   "[N] Output note file"
#define  XML_OUT_STR   "[X] Output XML file"

#define  EXP_STR   "[E] Expression Rendering"

#define  EXIT_STR          "[Q] Quit (Exit)"

#define  SRCH_BUF_SIZE 128
#define  VELTOP_BIAS    60
#define  BTTOP_BIAS     20
#define  damper_TOP_BIAS     20

#define  GPR_LINE_INTER  14
#define  GPR_LINE_BIAS  100
#define  GPR_LINE_LR_W  6
#define  GPR_LINE_LR_H  4

#define  GTTM_LINE_WIDTH  2


#define  FONT_NUM  256

#define  DEFAULT_TITLE_TITLE  ON
#define  DEFAULT_TITLE_PERFORMER  ON


/*  for   */
#define  GROUP_LINE_INTER  GPR_LINE_INTER
#define  GROUP_LINE_BIAS   0
#define  GROUP_LINE_LR_W   GPR_LINE_LR_W
#define  GROUP_LINE_LR_H   GPR_LINE_LR_H

#define  WORDS_EX    "*e"
#define  WORDS_SYNC  "*s"

#define  WORDS_VGS1  "s1"
#define  WORDS_VGE1  "e1"
#define  WORDS_VGA1  "a1"

#define  WORDS_VGS2  "s2"
#define  WORDS_VGE2  "e2"
#define  WORDS_VGA2  "a2"

#define  WORDS_NORM  "*"
/*  ܂ for   */

#define  LINE_NUM  128

#define  B_FILE_NUM  4096

#define  ON_DIFF_GRAB  1
#define  LEN_DIFF_GRAB 2
#define  ON_VEL_GRAB   3
#define  OFF_VEL_GRAB  4

#define  EVENT_WIDTH   6
#define  EVENT_DOT_SIZE   4


#define  CORPUS_SIZE  128


typedef struct _on_bias{
  TF on_time;
  double timestamp;
}ON_BIAS;


typedef struct _ahtbl{
  int num;
  char devifile[STR_LEN];
}AHTBL;


enum xyz {X=0, Y, Z };
enum rgba {R=0, G, B, A};


void title(void);

void usage(int argc, char *argv[]);

void thanks(void);

/* int SMF_out(char *org_filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num, */
/* 	    NOTE_HEADER *note_header_info, */
/* 	    SMF_HEADER *smf_header_info, WRITE_CTRL wctrl, PERF_CTRL pctrl); */
int SMF_out(char *org_filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num,
	    NOTE_HEADER *note_header_info,
	    SMF_HEADER *smf_header_info, WRITE_CTRL wctrl, PERF_CTRL pctrl, DRUM_DEF *drum_data);
/* int note2smf(NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num, */
/* 	     NOTE_HEADER *note_header_info, */
/* 	     EL *smf_top[MAX_TRK_NUM], SMF_HEADER *smf_header_info, WRITE_CTRL  wctrl, PERF_CTRL pctrl); */
int note2smf(NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num,
	     NOTE_HEADER *note_header_info,
	     EL *smf_top[MAX_TRK_NUM], SMF_HEADER *arg_smf_header_info, WRITE_CTRL  wctrl, PERF_CTRL pctrl,
	     DRUM_DEF *drum_data);

EL *sort_smf_list(EL *top);

int set_timestamp(NOTE_NODE *note_cur, EL *smf_cur, int timescale, int on_off,
		  PERF_CTRL pctrl, double time_mul[4], ON_BIAS on_bias, double tick_rate);
int set_disp_str(NOTE_NODE *note_cur, EL *smf_cur);

int calc_time_mul(double time_mul[4], int beat_bunbo, int divi);


/*  for COPER(Yutaka)  */
#define  DEVI_DB_SIZE  256

#define  RTGPR_NOTE_IDENT  "m0"
#define  DECIDE_DUR_NUM  32
#ifndef NOP
#define  NOP  (-128)
#endif

#define  Henle  0
#define  Peters 1

typedef struct _bt{
  double on_time;
  double beattime;
  double beattime_base;
  double on_time0;
  double rel_beattime;
}BT;


/*  for   */
typedef struct _gen_para{
  double g0_vel;
  double g1_vel;
  double ls1;
  double ls2;
  int default_vel[PART_NUM];
}GEN_PARA;


/*  for COPER  */
typedef struct _top_st{
  char filename[STR_LEN];
  double sim_val[SIM_C][SIM_L];
  double sim_score[SIM_L];
  struct _note_node *s;
  struct _note_node *e;
  NOTE_HEADER header_info;
}TOP_ST;

typedef struct _corpus_st{
  char filename[STR_LEN];
  NOTE_NODE *top;
  NOTE_NODE *linetop;
  NOTE_HEADER header_info;
}CORPUS_ST;


/*  for IGp  */
#define  GCHILD_NUM  16
typedef struct _garc{
  NOTE_NODE *s;
  NOTE_NODE *e;
  TF len;
  struct _garc *next;
  struct _garc *pre;
  struct _garc *child[GCHILD_NUM];
  struct _garc *parent;
}GARC;


/*  for IGp ܂ */

int saigen(char *org_filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num,
	    NOTE_HEADER *note_header_info,
	   SMF_HEADER *smf_header_info, WRITE_CTRL wctrl, PERF_CTRL pctrl);

int add_q_on_time(NOTE_NODE *part_top, NOTE_HEADER *note_header_info);

int pre_ins_beattime(NOTE_NODE *cur, BT btlist);

NOTE_NODE **devifile_read(NOTE_NODE *deviDB[DEVI_DB_SIZE], int *devifile_last);

int key_make(NOTE_NODE *part_top, char *keyident);

int devi_keyline_make(NOTE_NODE *deviDB[DEVI_DB_SIZE], NOTE_NODE *devi_key[DEVI_DB_SIZE], int devifile_last,
		      char *keyident);

int arff_out(char *org_filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num,
	     NOTE_HEADER *note_header_info, WRITE_CTRL wctrl, PERF_CTRL pctrl);

#if 0
int perf_render(char *org_filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int part_num,
	    NOTE_HEADER *note_header_info,
		SMF_HEADER *smf_header_info, WRITE_CTRL wctrl, PERF_CTRL pctrl);
#else
int perf_render(char *org_filename, NOTE_NODE **note_top, NOTE_HEADER *note_header_info,
		WRITE_CTRL wctrl, PERF_CTRL pctrl);
#endif

int atehame(NOTE_NODE **srch, AHTBL atehame_tbl, DRUM_DEF *drum_data);

int nov(int *argcp, char *argv[], char *filename, char *performer);

void nov_switcher(void);

int nov_init(int *argcp, char *argv[], char *filename, char *add_title_str);

void re_draw(void);

void resize(int width, int height);

void key_switcher(unsigned char key, int x, int y);

void Skey_switcher(int key, int x, int y);

int draw_all(NOTE_HEADER note_header_info, NOTE_NODE *view_note_cur, DRUM_DEF *drum_data);

void xbm_put(int x, int y, int z, int width, int height, unsigned char *xbm_bits, GLdouble colors[]);

int put_sf(double x, double y, double z, NOTE_NODE *cur, GLdouble colors[4]);

void mouse_menu(int sel);

void put_str(double x, double y, double z, GLdouble colors[4], char *arg_str);

void make_menu(void);

void disp_vel_value(double x, double y, double z, GLdouble colors[4], int vel);

void search_event(int button, int state, int x, int y);

void draw_H_line(int xs, int ys, int xe, int ye, GLdouble colors[4], int linewidth);

void draw_V_line(int xs, int ys, int xe, int ye, GLdouble colors[4], int linewidth);

int draw_event(NOTE_NODE *cur, double Lbot, double inter, double Velbot, double Veltop,
	       double ppqbeat, double alpha, double draw_on_time_bias, GLdouble arg_event_colors[8][4], DRUM_DEF *drum_data);

void draw_vel_stair(GLdouble event[8][3], double Velbot, double Veltop, int *Vel_val_top, int *Vel_val_bot, int on_vel, int off_vel,
		    GLdouble colors[8][4]);

void put_str_small(double x, double y, double z, GLdouble colors[4], char *arg_str);

double draw_gosen(double inter, GLdouble gosen_colors[][4], double *Lbot, double *Ltop);

int draw_NOTElist(NOTE_HEADER note_header_info, NOTE_NODE *view_note_cur, double Lbot, double Ltop, double inter,
		  double Velbot, double Veltop, double BTbot, double BTtop, int BTl, int BTh,
		  double damper_bot, double damper_top,
		  double ppqbeat, double alpha, DRUM_DEF *drum_data);

void put_str_large(double x, double y, double z, GLdouble colors[4], char *arg_str);

void put_str_huge(double x, double y, double z, GLdouble colors[4], char *arg_str);

void extern_SMF_out(void);

void extern_sequence_play(void);

void disp_key_help(void);

void open_key_help_win(void);
void close_key_help_win(void);
void help_win_flush(void);


int tyou_infer(NOTE_NODE *top);
int scale_chk(int note_num, int tyou);


/* int _4R_file_out(char *org_filename, int ext_type, NOTE_NODE *note_top, NOTE_HEADER *note_header_info, */
/* 		 int smf_divi, WRITE_CTRL  wctrl, xmlDoc *xml_doc_top); */
int _4R_file_out(char *org_filename, int ext_type, NOTE_NODE *note_top, NOTE_HEADER *note_header_info,
		 int smf_divi, WRITE_CTRL  wctrl, xmlDoc *xml_doc_top, DRUM_DEF *drum_data);

/* xmlDoc *note2xml(NOTE_NODE *note_top, NOTE_HEADER *note_header_info); */
xmlDoc *note2xml(NOTE_NODE *note_top, NOTE_HEADER *note_header_info, DRUM_DEF *drum_data);

xmlNode *gen_MusicXML_header(xmlNode **xml_top, NOTE_NODE *note_top, NOTE_HEADER *note_header_info);

/* xmlNode *gen_MusicXML_body(xmlNode **xml_top, NOTE_NODE *note_top, NOTE_HEADER *note_header_info); */
xmlNode *gen_MusicXML_body(xmlNode **xml_top, NOTE_NODE *note_top, NOTE_HEADER *note_header_info, DRUM_DEF *drum_data);

xmlNode *gen_XML_time(xmlNode **xml_attr, int bunsi, int bunbo);

xmlNode *gen_XML_sound(xmlNode **xml_meas, NOTE_HEADER *note_header_info);

/* xmlNode *gen_XML_note(xmlNode **xml_meas, NOTE_NODE *note_cur, int divi, double beat_bunbo); */
xmlNode *gen_XML_note(xmlNode **xml_meas, NOTE_NODE *note_cur, int divi, double beat_bunbo, DRUM_DEF *drum_data);

int gpr_read(char *filename);

int disp_gpr(double Lbot);

double disp_gpr_group(xmlNode *group_top, double Lbot, int level, NOTE_NODE **s_note_node, NOTE_NODE **e_note_node);

int get_node_xml_id(char *note_id, xmlNode **xml_node, NOTE_NODE **note_node);

void draw_gpr_line(NOTE_NODE *s_node, NOTE_NODE *e_node, int Lbot, int level, double len);

void dur2type(int dur, char *type_str, int divi, double bar_haku);

xmlNode *gen_XML_measure(xmlNode **xml_part, NOTE_NODE *note_cur, int *meas_num);

/* int gttm(char gttm_dir[STR_LEN], NOTE_NODE *arg_top, char *apply_line); */
int gttm(char *gttm_dir);

int gpr2a(NOTE_NODE *linetop);

int draw_GTTM_value(NOTE_NODE *cur, double ppqbeat, double draw_on_time_bias, double Ltop);

void set_gosen_colors(void);

void set_event_colors(char *flag, GLdouble event_colors[8][4]);

void modify_event(int x, int y);

int gpr2b(NOTE_NODE *linetop);

int gpr3a(NOTE_NODE *linetop);

int gpr3b(NOTE_NODE *linetop);

void srch_chk(int srch_x, int srch_y, int region_y, NOTE_NODE **srch_cur,
	      NOTE_NODE *cur, GLdouble event[8][3], double Vel_val_top, double Vel_val_bot);


int gpr3c(NOTE_NODE *linetop);

int gpr3d(NOTE_NODE *linetop);

void draw_str_note(NOTE_NODE *cur, int win_w, int win_h, int srch_x, int srch_y, int draw_color);

void init_arti_dur(ARTI_DUR *arti_dur);

void set_GLcolors_by_X11name(char *colorname, GLdouble event_colors[8][4]);

void mouse_move(int x, int y);

void rotate_gosen(int x, int y);

int get_n4(NOTE_NODE *cur, NOTE_NODE *n[4], int mode);

int gpr1(NOTE_NODE *linetop);

void draw_GPR1_result(NOTE_NODE *cur, double gpr_x, int draw_color, double Ltop);

double get_lenrest(NOTE_NODE *s, NOTE_NODE *e);

int gpr5(NOTE_NODE *linetop);

GARC *calc_gpr5(GARC *gtop, NOTE_NODE *s, NOTE_NODE *e, int level);

GARC *garc_alloc(void);

void garc_free(GARC *gtop);

void draw_gpr5(GARC *gcur, double Lbot, int level);

int gpr6(NOTE_NODE *linetop);

GARC *calc_gpr5(GARC *gtop, NOTE_NODE *s, NOTE_NODE *e, int level);

int h_gpr6(NOTE_NODE *linetop);

void disp_gttm_value(int chk_mode, char *arg_file, NOTE_NODE *cur, char gttm_line[STR_LEN]);

/*  RTgpr  ܂  */


/*  for PopE  */
int genchan(void);

void init_gen_para(GEN_PARA *gen_para);

int draw_gen_mark(NOTE_HEADER note_header_info, NOTE_NODE *view_note_cur, double Lbot, double Ltop, double inter,
		  double Velbot, double Veltop, double BTbot, double BTtop, int BTl, int BTh,
		  double damper_bot, double damper_top,
		  double ppqbeat, double alpha);

void draw_group_line(NOTE_NODE *s_node, NOTE_NODE *e_node, int Ltop, int level);

void rainbow_vel(char *start_words, char *apex_words, char *end_words, double top_amp);

void len_modify_shift(char *chk_words, double len_amp);

void usage_genchan(void);

void draw_gen_point(char *chk_words, char *draw_color, DRUM_DEF *drum_data);

void draw_gen_line(char *chk_words, char *draw_color);

void scaling_sync(char *sync_words_base, char *sync_words);

NOTE_NODE *bar_adj_forward(NOTE_NODE *top, NOTE_HEADER *note_header_info);

void all_TFcopy(NOTE_NODE *top);

void velval_swap(NOTE_NODE *cur);

void all_velval_swap(NOTE_NODE *top);

void on_time_len_swap(NOTE_NODE *cur);

void all_on_time_len_swap(NOTE_NODE *top);


/*  for PopE  ܂  */

/*  RTgpr  */
/*  predbound  */
void RTgpr_body(int para);

void RTgpr(int *argcp, char *argv[], char *filename);

void e2note(EL *e_cur, NOTE_NODE **note_cur, double tempo_usec);

xmlNode *gen_GPR_XML(xmlNode **xml_top, NOTE_NODE *note_top, NOTE_HEADER *note_header_info);

xmlNode *XML_write(char *arg_file,
		   xmlNode *xml_top, xmlNode *gpr_top,
		   NOTE_NODE *note_top, NOTE_HEADER  *note_header_info,
		   WRITE_CTRL wctrl);

void pre_alloc(void);

/*    RTgpr  */


/*  for COPER  */
int coper(char *corpus_dir, char *target_file, WRITE_CTRL wctrl);

void notelist_display(NOTE_NODE *top);

void calc_sim(CORPUS_ST *target, CORPUS_ST corpus_data[], int nfiles, WRITE_CTRL wctrl);

NOTE_NODE *search_memo_node(NOTE_NODE **srch_s, NOTE_NODE **key_s);

double sim_abs_pitch(NOTE_NODE *key_s, NOTE_NODE *key_e,
		     NOTE_NODE *corpus_s, NOTE_NODE *corpus_e);

double sim_abs_len(NOTE_NODE *key_s, NOTE_NODE *key_e,
		   NOTE_NODE *corpus_s, NOTE_NODE *corpus_e);

double sim_rel_pitch(NOTE_NODE *key_s, NOTE_NODE *key_e,
		     NOTE_NODE *corpus_s, NOTE_NODE *corpus_e);

double sim_rel_len(NOTE_NODE *key_s, NOTE_NODE *key_e,
		   NOTE_NODE *corpus_s, NOTE_NODE *corpus_e);

void simtop_copy(TOP_ST dst, TOP_ST src);

void notelist_display_fromto(NOTE_NODE *from, NOTE_NODE *to);

void apply_devi(NOTE_NODE *t_s, NOTE_NODE *t_e, NOTE_NODE *c_s, NOTE_NODE *c_e);

void add_skip(NOTE_NODE *top, int skip_ident);

void all_devi_rm(NOTE_NODE *top);

double calc_qbeattime(double beattime, double beattime_base, double bpm, double bpm_base);

double gpr6_X(NOTE_NODE *bci, int r, int person);

int chk_gpr_bc(NOTE_NODE *chk_node, int person);

double gpr6_Y(NOTE_NODE *arg_bci, NOTE_NODE *arg_bcj, int arg_r, int person, double match_th);

double gpr6_Z(NOTE_NODE *arg_bci, NOTE_NODE *arg_bcj, int arg_r, int person, double match_th);

int chk_last_note(NOTE_NODE *chk_node);

#endif
