/*  Time-stamp: <2005-02-18 12:43:03 >  */
#include  "4ru.h"


void calc_sim(CORPUS_ST *target, CORPUS_ST corpus_data[], int nfiles, WRITE_CTRL wctrl)
{
  NOTE_NODE *cur = NULL;
  NOTE_NODE *srch = NULL;
  NOTE_NODE *corpus_srch = NULL;
  NOTE_NODE *key_s = NULL;
  NOTE_NODE *key_e = NULL;
  NOTE_NODE *corpus_s = NULL;
  NOTE_NODE *corpus_e = NULL;
  NOTE_NODE *corpus_cur = NULL;
  TOP_ST simtop[10][2];
  int corpus_i;
  char match_filename[STR_LEN];
  char filename_tmp[STR_LEN];
  char rendered_filename[STR_LEN];

  int i;
  int j;
  int k;
  int lv;
  int target_c;
  int corpus_c;


  /* simtop init  */
  for(k = 0; k < 2; k++){
    for(i = 0; i < 10; i++){
      for(j = 0; j < SIM_C; j++){
	for(lv = 0; lv < 2; lv++){
	  simtop[i][k].sim_val[j][lv] = -32768.0;
	}
	simtop[i][k].sim_score[j] = -32768.0;
      }
      simtop[i][k].s = NULL;
      simtop[i][k].e = NULL;
/*       simtop[i][k].header_info = NULL; */
    }
  }
  /* init ܂ */

  /*  TARGET  */
  cur = target->linetop;
  key_s = NULL;
  key_e = NULL;
  search_memo_node(&cur, &key_e);
  if(key_e == NULL){  return; }

  target_c = 0;
  corpus_c = 0;
  while(1){
    key_s = key_e;
    /* s, e Zbg  */
    cur = key_e->next;
    search_memo_node(&cur, &key_e);
    if(key_e == NULL){  break; }

    /* simtop init  */
    for(k = 0; k < 2; k++){
      for(i = 0; i < 10; i++){
	for(j = 0; j < SIM_C; j++){
	  for(lv = 0; lv < 2; lv++){
	    simtop[i][k].sim_val[j][lv] = -32768.0;
	  }
	  simtop[i][k].sim_score[j] = -32768.0;
	}
	simtop[i][k].s = NULL;
	simtop[i][k].e = NULL;
	/*       simtop[i][k].header_info = NULL; */
      }
    }
    /* init ܂ */


    /*  CORPUS  */
    corpus_c = 0;
    for(corpus_i = 0; corpus_i < nfiles; corpus_i++){
      corpus_cur = corpus_data[corpus_i].linetop;
      corpus_s = NULL;
      corpus_e = NULL;
      search_memo_node(&corpus_cur, &corpus_e);
      if(corpus_e == NULL){  return; }
      while(1){
	corpus_s = corpus_e;
	/* s, e Zbg  */
	corpus_cur = corpus_e->next;
	search_memo_node(&corpus_cur, &corpus_e);
	if(corpus_e == NULL){  break; }
	corpus_c++;
	/* ====== Calc! koko  ====== */
	srch = key_s->next;
	corpus_srch = corpus_s->next;
	for(i = 0; i < SIM_C; i++){
	  for(j = 0; j < SIM_L; j++){
	    corpus_s->sim_val[i][j] = 0.0;
	  }
	}
	for(j = 0; j < SIM_L; j++){
	  corpus_s->sim_score[j] = 0.0;
	}
	corpus_s->sim_val[0][0] = sim_abs_pitch(key_s, key_e, corpus_s, corpus_e);
	corpus_s->sim_val[1][0] = sim_abs_len(key_s, key_e, corpus_s, corpus_e);
	corpus_s->sim_val[0][1] = sim_rel_pitch(key_s, key_e, corpus_s, corpus_e);
	corpus_s->sim_val[1][1] = sim_rel_len(key_s, key_e, corpus_s, corpus_e);

	for(lv = 0; lv < SIM_L; lv++){
	  corpus_s->sim_score[lv] = (corpus_s->sim_val[0][lv] + corpus_s->sim_val[1][lv]) / SIM_C;
/* 	  printf("sim_score[%d]: %5.3f\n", lv, corpus_s->sim_score[lv]); */
	}

	/* ====== Calc! koko ܂ ====== */
	for(lv = 0; lv < 2; lv++){
	  for(i = 0; i < 10; i++){
	    if(simtop[i][lv].sim_score[lv] < corpus_s->sim_score[lv]){
	      for(j = 9; j > (i+1); j--){
		simtop_copy(simtop[j][lv], simtop[j-1][lv]);  /*  dst <- src  */
	      }
	      strcpy(simtop[i][lv].filename, corpus_data[corpus_i].filename);
	      simtop[i][lv].sim_val[0][0] = corpus_s->sim_val[0][0];
	      simtop[i][lv].sim_val[0][1] = corpus_s->sim_val[0][1];
	      simtop[i][lv].sim_val[1][0] = corpus_s->sim_val[1][0];
	      simtop[i][lv].sim_val[1][1] = corpus_s->sim_val[1][1];
	      simtop[i][lv].sim_score[0] = corpus_s->sim_score[0];
	      simtop[i][lv].sim_score[1] = corpus_s->sim_score[1];
	      simtop[i][lv].header_info = corpus_data[corpus_i].header_info;
	      simtop[i][lv].s = corpus_s;
	      simtop[i][lv].e = corpus_e;
	      break;
	    }
	  }
	}
      }
    }

    puts("====== TARGET ======");
/*     notelist_display_fromto(key_s, key_e); */
    puts("====== top10 ======");
    for(lv = 0; lv < 2; lv++){
      for(i = 0; i < 10; i++){
	if(simtop[i][lv].sim_score[lv] < 0){  break; }
	printf("%02d [%d]: %5.3f: %s\n", i, lv, simtop[i][lv].sim_score[lv], simtop[i][lv].filename);
/* 	puts("====== from ======"); */
/* 	notelist_display_fromto(simtop[i][lv].s->org_node, simtop[i][lv].e->org_node); */
/* 	sprintf(match_filename, "%02d-%02di-%02dlv-%s.match", target_c, i, lv, simtop[i][lv].filename + 36); */

	get_cmd_name(simtop[i][lv].filename, filename_tmp);
	sprintf(match_filename, "%02d-%02di-%02dlv-%s.match", target_c, i, lv, filename_tmp);
	NOTEfile_write_fromto(simtop[i][lv].filename, match_filename, &(simtop[i][lv].header_info),
			      simtop[i][lv].s->org_node, wctrl, simtop[i][lv].s->org_node, simtop[i][lv].e->org_node);

/* 	puts("====== to ======"); */
      }
    }

    /*  t\]  */
/*     notelist_display_fromto(simtop[0][0].s->org_node, simtop[0][0].e->org_node); */
/*     getchar(); */
/*     apply_devi(key_s->org_node, key_e->org_node, simtop[0][0].s, simtop[0][0].e); */

    if( (simtop[0][0].s != NULL) && (simtop[0][0].e != NULL) ){
      printf("Apply[0][0]: %s\n", simtop[0][0].filename);
      apply_devi(key_s->org_node, key_e->org_node, simtop[0][0].s->org_node, simtop[0][0].e->org_node);
    }else if( (simtop[0][1].s != NULL) && (simtop[0][1].e != NULL) ){
      printf("Apply[0][1]: %s\n", simtop[0][1].filename);
      apply_devi(key_s->org_node, key_e->org_node, simtop[0][1].s->org_node, simtop[0][1].e->org_node);
    }


/*     puts("====== TARGET ======"); */
/*     notelist_display_fromto(key_s, key_e); */
/*     puts("====== top10 ======"); */
/*     lv = 0; */
/*     i = 4; */
/*     printf("%02d [%d]: %5.3f: %s\n", i, lv, simtop[i][lv].sim_score[lv], simtop[i][lv].filename); */
/*     puts("====== from ======"); */
/*     notelist_display_fromto(simtop[i][0].s, simtop[i][0].e); */
/*     puts("====== to ======"); */

/*     break;  /\*  RgAEgƁCTARGET ׂ̂Ă̊yȒfЂɑ΂ėގT  *\/ */
    target_c++;
  }

  printf("target_c: %d\n", target_c);
  printf("corpus_c: %d\n", corpus_c);

  get_cmd_name(target->filename, filename_tmp);
  sprintf(rendered_filename, "%s.rendered", filename_tmp);
  NOTEfile_write(target->filename, rendered_filename, &(target->header_info), target->top, wctrl);

  exit(0);

}
