/*  Time-stamp: <2004-12-13 17:14:16 >  */
#include  "4ru.h"


extern xmlDoc *xml_doc_top;
extern NOTE_NODE *note_top;
extern NOTE_NODE *note_bot;

int get_node_xml_id(char *note_id, xmlNode **xml_node, NOTE_NODE **note_node)
{
  char part_id[STR_LEN];
  char meas_id[STR_LEN];
  char num_id[STR_LEN];
  int len;
  int idx;
  int i;
  xmlNode *xml_cur;
  int num_num;
  int note_count;
  static NOTE_NODE *note_cur;
  NOTE_NODE *note_same;


  *xml_node = NULL;
  *note_node = NULL;

  len = strlen(note_id);

  idx = 0;
  for(i = 0; i <= len; i++){
    if(note_id[i] == '-'){
      i++;
      break;
    }
    part_id[idx] = note_id[i];
    idx++;
  }
  part_id[idx] = '\0';

  idx = 0;
  for(; i <= len; i++){
    if(note_id[i] == '-'){
      i++;
      break;
    }
    meas_id[idx] = note_id[i];
    idx++;
  }
  meas_id[idx] = '\0';

  idx = 0;
  for(; i <= len; i++){
    if(note_id[i] == '-'){
      break;
    }
    num_id[idx] = note_id[i];
    idx++;
  }
  num_id[idx] = '\0';
  if(sscanf(num_id, "%d", &num_num) != 1){
    return EXIT_SUCCESS;
  }


  if(xml_doc_top != NULL){
    xml_cur = xmlDocGetRootElement(xml_doc_top);
    while(xml_cur != NULL){
      if(strcmp(xml_cur->name, "score-partwise") == 0){  break; }
      xml_cur = xml_cur->next;
    }
    if(xml_cur == NULL){  return EXIT_FAILURE; }

    xml_cur = xml_cur->children;
    /*  now: xml_cur == ("score-partwise" $B$N0l$D2<(B)  */
    while(xml_cur != NULL){
      if(strcmp(xml_cur->name, "part") == 0){
	if(xmlStrcmp(xmlGetProp(xml_cur, "id"), part_id) == 0){
	  break;
	}
      }
      xml_cur = xml_cur->next;
    }
    if(xml_cur == NULL){  return EXIT_FAILURE; }

    xml_cur = xml_cur->children;
    /*  now: xml_cur == ("part" $B$N0l$D2<(B)  */
    while(xml_cur != NULL){
      if(strcmp(xml_cur->name, "measure") == 0){
	if(xmlStrcmp(xmlGetProp(xml_cur, "number"), meas_id) == 0){
	  break;
	}
      }
      xml_cur = xml_cur->next;
    }
    if(xml_cur == NULL){  return EXIT_FAILURE; }

    xml_cur = xml_cur->children;
    /*  now: xml_cur == ("meas" $B$N0l$D2<(B)  */

    note_count = 0;
    while(xml_cur != NULL){
      if(strcmp(xml_cur->name, "note") == 0){
	note_count++;
	if(note_count == num_num){
	  (*xml_node) = xml_cur;
	  break;
	}
      }
      xml_cur = xml_cur->next;
    }
    if(xml_cur == NULL){  return EXIT_FAILURE;  }

    if(note_top != NULL){
      note_cur = note_top;
      while(1){
	if(note_cur == NULL){  break; }
	note_same = note_cur;
	while(1){
	  if(note_same == NULL){  break; }
	  if(note_same->xmlnode == (*xml_node)){
	    (*note_node) = note_same;
	    break;
	  }
	  note_same = note_same->samenext;
	}

	if(note_cur == note_bot){  break; }
	note_cur = note_cur->next;
      }
    }

  }


  return EXIT_SUCCESS;

}
