/*  Time-stamp: <2005-05-11 16:55:12 >  */
#include  "midi_io.h"
#include  "4ru.h"


#ifdef _4RU_H
extern double ppqbeat;
extern int RTgpr_mode;
extern EL *decide_dur[DECIDE_DUR_NUM];
extern int should_re_draw;
extern PERF_CTRL pctrl;
/* static int midiin_scaling = ON; */
static int seq_button = STOP;
int dec_dur_i = 0;
#endif

/*  obt@nh𕡐ȂƂȂ˂  */

extern int midiin_called;
extern int midi_in_through;
extern int midiin_mode;
extern int midinote_in;

static int midiout_init_called = OFF;
static int midiin_init_called = OFF;
static int f8counter;

#ifdef CYGWIN
static HMIDIOUT MIDI_out_Handle;
static MIDIOUTCAPS MIDI_out_caps;
static DWORD counter_timerID = -1;
static HMIDIIN  MIDI_in_Handle;
static MIDIINCAPS MIDI_in_caps;
#endif

#ifdef OSX
static  MIDIEndpointRef  gDest;
static  MIDIPortRef  gOutPort;
static  Byte buffer[1024];
static  MIDIPacketList  *MidiPktList;
static  MIDIPacket  *CurPkt;

static MIDIEndpointRef gSrc;
static MIDIClientRef in_client = NULL;
static MIDIPortRef inPort = NULL;
static MIDIPacket *in_packet;
static double ticks_sec;

#define  CLISTR  "MIDIio"
#define  INCLISTR "Input port"
#endif


#ifdef ALGO1
static DWORD pre_time;
#endif
/*    */
static UINT  OutDeviceNum;
static WORD  timerRes;
static WORD now_time;
static DWORD wrap_bias;

static int start_stop = COUNTER_STOP;
static double int_tick;
static double counter;
static double pause_tick;
static double pause_time;


static int out_port[PORT_NUM_BUFSIZE];
static int in_port[PORT_NUM_BUFSIZE];

#define _1000 1000.0

extern  NOTE_NODE *note_top;
extern  NOTE_NODE *note_bot;
extern  NOTE_NODE *note_cur;
extern  NOTE_HEADER note_header;

extern  NOTE_NODE *view_note_cur;

extern  EL *e_top;
extern  EL *e_bot;
extern  EL *e_cur;
extern  SMF_HEADER  smf_header;


double get_counter(void)
{
  return counter - pause_time;
}


/*  1 BEAT  1000 count up */
#ifdef  CYGWIN
void CALLBACK count_up(UINT timerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
#else
void count_up(int intarg)
#endif
{
  if(start_stop == COUNTER_STOP){
    return;
  }

  /*  Warning ΍  */
#ifndef CYGWIN
  intarg = intarg;
#else
  timerID = timerID;
  uMsg = uMsg;
  dwUser = dwUser;
  dw1 = dw1;
  dw2 = dw2;
#endif

#ifndef ALGO1
  if(pause_tick > 0.0){
    pause_tick -= int_tick;
  }else if(pause_tick < 0.0){
    counter -= pause_tick;
    pause_tick = 0;
  }else{
    counter += int_tick;
    /*    pause_time = 0;  */
  }

#else  /*  not defined ALGO1  */

#ifdef CYGWIN
  now_time = timeGetTime();
  counter += (now_time - pre_time) * 2.0;
#else  /*  OS X  */
  now_time = AudioGetCurrentHostTime();
  counter += now_time - pre_time;
#endif
#endif  /*  end of ALGO1  */
}


int init_counter_tick_up(double qbpm, double init_counter_val)
{
#ifdef CYGWIN
  MMRESULT ret;
  TIMECAPS tc;
  WORD period;
#endif


#ifdef CYGWIN
  /*  Cygwin  */
  ret = timeGetDevCaps(&tc, sizeof(TIMECAPS));
  if(ret != TIMERR_NOERROR){
    return EXIT_FAILURE;
  }

  period = 1;
  timerRes = min(max(tc.wPeriodMin, period), tc.wPeriodMax);

  ret = timeBeginPeriod(timerRes);
  if(ret != TIMERR_NOERROR){
    return EXIT_FAILURE;
  }
  /*  Cygwin  */
#endif
#ifdef OSX
  /*  OS X  */
  timerRes = AudioGetHostClockMinimumTimeDelta();
  timerRes = AudioGetHostClockFrequency();
  timerRes = 1;  /*  1msec.  */
  /*  OS X  */
#endif

#ifdef CYGWIN
  /*  Cygwin  */
  counter_timerID =
    timeSetEvent(timerRes, timerRes, (LPTIMECALLBACK)count_up, (DWORD)NULL, TIME_PERIODIC);
  if(counter_timerID == (DWORD)NULL){
    return EXIT_FAILURE;
  }
  /*  Cygwin  */
#endif
#ifdef OSX
  /*  OS X  */
  signal(SIGALRM, count_up);
  ualarm(timerRes * 1000, !0);
  /*  alarm(timerRes);  */
  /*  OS X  */
#endif

  /*  timeGetTime() œ鎞CԂľ^ŕ\łl wrap Ƃ̕␳l  */
  wrap_bias = 0x01 << ((sizeof(now_time) * 8) - 2);

  calc_BPM_int_tick(qbpm);  /*  int_tick ɐݒ肳  */
  
  counter = init_counter_val - (_1000 * 1.0 / timerRes * int_tick);

  pause_tick = 0;
  pause_time = 0;

  return EXIT_SUCCESS;
}


void start_counter(void)
{
#ifndef ALGO1

  start_stop = COUNTER_START;

#else

  pre_time = timeGetTime();
  start_stop = COUNTER_START;

#endif
}


void stop_counter(void)
{
#ifndef ALGO1

  start_stop =  COUNTER_STOP;

#else

  pre_time = timeGetTime();
  start_stop = COUNTER_STOP;

#endif
}


int close_counter(void)
{
#ifdef  CYGWIN
  if(timeKillEvent(counter_timerID) == TIMERR_NOERROR){
    counter_timerID = -1;
    return EXIT_SUCCESS;
  }else{
    counter_timerID = -1;
    return EXIT_FAILURE;
  }
#else

  return  EXIT_SUCCESS;
#endif
}


int get_midi_out_num(int *out_num)
{
#ifdef  CYGWIN
  if((OutDeviceNum = midiOutGetNumDevs()) == 0){
    br_printf(2, "gpł MIDI OUT foCX܂D\n");
    *out_num = -1;
    return EXIT_FAILURE;
  }
  *out_num = (int)OutDeviceNum;
#endif
#ifdef OSX
  /*  OS X  */
  if((OutDeviceNum = MIDIGetNumberOfDestinations()) == 0){
    br_printf(-1, "gpł MIDI OUT foCX܂D\n");
    *out_num = -1;
    return EXIT_FAILURE;
  }
  *out_num = (int)OutDeviceNum;
#endif
#ifdef LINUX
  OutDeviceNum = 0;
  *out_num = (int)OutDeviceNum;
#endif

  return EXIT_SUCCESS;
  
}


int open_midi_out(int arg_out_port)
{
  int i;
  int out_port_idx;

#ifdef OSX
  /*  OS X  */
  MIDIClientRef client = NULL;
  CFStringRef pname;
  char name[1024];
#endif

  if(midiout_init_called == OFF){
    midiout_init_called = ON;
    for(i = 0; i < PORT_NUM_BUFSIZE; i++){
      out_port[i] = NOT_PORT_NO;
    }

  }

  for(out_port_idx = 0; out_port_idx < PORT_NUM_BUFSIZE; out_port_idx++){
    if(out_port[out_port_idx] == NOT_PORT_NO){
      out_port[out_port_idx] = arg_out_port;
      break;
    }
  }
  if(out_port_idx >= PORT_NUM_BUFSIZE){
    br_printf(6, "%s: %d: PORT_NUM_BUFSIZE  %d 傫čăRpCĂD\n", __FILE__, __LINE__,
	      PORT_NUM_BUFSIZE);
    return EXIT_FAILURE;
  }


#ifdef CYGWIN
  midiOutGetDevCaps((UINT)out_port[out_port_idx], &MIDI_out_caps, sizeof(MIDI_out_caps));
  printf("Open %s... ", MIDI_out_caps.szPname);
  /*  hwnd: bZ[W`EBhẼnh  */
  /*
    if(midiOutOpen(&MIDI_out_Handle, (UINT)out_port[out_port_idx], (HWND)hwnd, (DWORD)NULL, CALLBACK_WINDOW)){
  */
  if(midiOutOpen(&MIDI_out_Handle, (UINT)out_port[out_port_idx], (DWORD)NULL, (DWORD)NULL, CALLBACK_NULL)
     == MMSYSERR_NOERROR){
    br_printf(5, "Ok!\n");
  }else{
    br_printf(2, "NG.\n");
    return EXIT_FAILURE;
  }
#endif
#ifdef OSX
  /*  OS X  */
  gDest = MIDIGetDestination(out_port[out_port_idx]);
  if(gDest != NULL){
    MIDIObjectGetStringProperty(gDest, kMIDIPropertyName, &pname);
    CFStringGetCString(pname, name, sizeof(name), 0);
    CFRelease(pname);
  }
  printf("Open %s... ", name);

  MIDIClientCreate(CFSTR("MIDI Echo"), NULL, NULL, &client);
  if(MIDIOutputPortCreate(client, CFSTR("Output port"), &gOutPort) == EXIT_SUCCESS){
    br_printf(5, "Ok!\n");

    return EXIT_SUCCESS;

  }else{
    br_printf(2, "NG\n");
    return EXIT_FAILURE;
  }
#endif

  return EXIT_SUCCESS;

}


int close_midi_out(int arg_out_port)
{
  int i;
  int vals;


  if(midiout_init_called == OFF){
    return  EXIT_SUCCESS;
  }

  for(i = 0; i < PORT_NUM_BUFSIZE; i++){
    if(out_port[i] == arg_out_port){
      out_port[i] = NOT_PORT_NO;
      break;
    }
  }
  if(i == PORT_NUM_BUFSIZE){
    midiout_init_called = OFF;
    return EXIT_SUCCESS;
  }

  for(i = 0; i < 16; i++){
    midi_out(0, 0xb0 + i, 0x7b, 0x00, &vals);  /*  all note_off  */
    midi_out(0, 0xb0 + i, 0x78, 0x00, &vals);  /*  all note_off  */
  }

/*   stop_counter(); */
/*   close_counter(); */

#ifdef ALGO1
    pre_time = 0;
#endif

    now_time = 0;
    int_tick = 0;
    counter = 0;
    pause_tick = 0;
    pause_time = 0;
    timerRes = 0;


    br_printf(-1, "\n");

#ifdef CYGWIN
  /*  MIDI OUT foCXgȈ  */
  printf("Reset %s... ", get_midi_out_name(arg_out_port));
  if(midiOutReset(MIDI_out_Handle) == MMSYSERR_NOERROR){
    br_printf(5, "Ok!\n");
  }
  else{
    br_printf(2, "NG.\n");
  }

  printf("Close %s... ", get_midi_out_name(arg_out_port));
  if(midiOutClose(MIDI_out_Handle) == MMSYSERR_NOERROR){
    br_printf(5, "Ok!\n");
    return EXIT_SUCCESS;
  }
  else{
    br_printf(2, "NG.\n");
    return EXIT_FAILURE;
  }

  return EXIT_FAILURE;

#endif

#ifdef OSX
  /*  OS X  */
  printf("Reset %s... ", get_midi_out_name(arg_out_port));
  if((gDest = MIDIGetDestination(arg_out_port)) != NULL){
    br_printf(5, "Ok!\n");
  }
  else{
    br_printf(2, "NG.\n");
  }

  printf("Close %s... ", get_midi_out_name(arg_out_port));


  if(MIDIPortDispose(gOutPort) == EXIT_SUCCESS){
    br_printf(5, "Ok!\n");
    return EXIT_SUCCESS;
  }
  else{
    br_printf(2, "NG.\n");
    return EXIT_FAILURE;
  }

#endif
#ifdef LINUX
  return EXIT_FAILURE;
#endif

}


void midi_out(int time, int stat, int val1, int val2, int *vals)
{
#ifdef  CYGWIN
  static int i;
  static DWORD ValPack;
  static BYTE LongBuffer[256];
  static MIDIHDR LongValPack;
  static int size = sizeof(MIDIHDR);
#endif
#ifdef OSX
  /*  OS X  */
  static int i;
  Byte  note_data[256];
#endif
#ifdef LINUX
  ;  /*  not implemented yet.  */
  val1 = val1;
  val2 = val2;
  vals = vals;
#endif

  time = time;  /*  Warning ΍ (RpC̍œKŏł邱Ƃ) */

  if(stat != 0xf0){
#ifdef CYGWIN
    ValPack = 0;
    ValPack += stat;
    ValPack += val1 * 256;
    ValPack += val2 * 256 * 256;
    midiOutShortMsg(MIDI_out_Handle, ValPack);
#endif
#ifdef OSX
    /*  OS X  */
    note_data[0] = stat;
    note_data[1] = val1;
    if(val2 != 0){
      note_data[2] = val2;
    }else{
      note_data[2] = 0;
    }
    MidiPktList = (MIDIPacketList *)buffer;
    CurPkt = MIDIPacketListInit(MidiPktList);
    CurPkt = MIDIPacketListAdd(MidiPktList, sizeof(buffer), CurPkt,
			       0, 3, note_data);
    
    MIDISend(gOutPort, gDest, MidiPktList);
#endif
  }else{
#ifdef CYGWIN
    LongValPack.lpData = LongBuffer;
    LongValPack.dwBufferLength = val2 + 1;
    LongValPack.dwFlags = 0;
    *(LongValPack.lpData + 0) = stat;
    for(i = 0; i < val2; i++){
      *(LongValPack.lpData + i + 1) = *(vals + i);
    }
    midiOutPrepareHeader(MIDI_out_Handle, &LongValPack, size);
    midiOutLongMsg(MIDI_out_Handle, &LongValPack, size);
#endif
#ifdef OSX
    /*  OS X  */
    note_data[0] = stat;
    for(i = 0; i < val2; i++){
      note_data[i + 1] = *(vals + i);
    }

    MidiPktList = (MIDIPacketList *)buffer;
    CurPkt = MIDIPacketListInit(MidiPktList);
    CurPkt = MIDIPacketListAdd(MidiPktList, sizeof(buffer), CurPkt,
			       0, val2 + 1, note_data);
    
    MIDISend(gOutPort, gDest, MidiPktList);
#endif
  }
}


void calc_BPM_int_tick(double qbpm)
{
#ifdef  CYGWIN
  int_tick = (_1000 / ((60000.0 / qbpm) / (double)timerRes));
#endif
#ifdef OSX
  int_tick = (_1000 / ((60000.0 / qbpm) / (double)timerRes)) * 10.0;
#endif
#ifdef LINUX
  ;  /*  not implemented yet.  */
  qbpm = qbpm;
#endif
}


void set_tempo_usec(double tempo_usec)
{
#ifdef  CYGWIN
  int_tick = (_1000 / (tempo_usec / 1000.0) ) * timerRes;
#endif
#ifdef OSX
  int_tick = (_1000 / (tempo_usec / 1000.0) ) * timerRes * 10.0;
#endif
#ifdef LINUX
  ;  /*  not implemented yet.  */
  tempo_usec = tempo_usec;
#endif
}


void calc_BEATTIME_int_tick(double beattime)
{
  int_tick = (_1000 / (beattime / (double)timerRes));
}


int select_midi_out(void)
{
  char buf[1024];
  int num;
  int i;
  int port;


#ifdef CYGWIN
  num = midiOutGetNumDevs();
#endif
#ifdef OSX
  /*  OS X  */
  num = MIDIGetNumberOfDestinations();
#endif
#ifdef LINUX
  i = i;
  num = 0;
#endif

  if(num == 0){
    printf("No MIDI destinations present\n");
    exit(EXIT_FAILURE);
  }

#ifdef CYGWIN
  for(i = MIDI_MAPPER; i < num; i++){
    printf("%2d: %s\n", i, get_midi_out_name(i));
  }
#endif
#ifdef OSX
  /*  OS X  */
  for(i = 0; i < num; i++){
    printf("%2d: %s\n", i, get_midi_out_name(i));
  }
#endif

  fgets(buf, sizeof(buf), stdin);
  if(sscanf(buf, "%d", &port) == 1){
    return port;
  }else{
    return -1;
  }

  return EXIT_SUCCESS;

}


char *get_midi_out_name(int port)
{
#ifdef  CYGWIN
  midiOutGetDevCaps(port, &MIDI_out_caps, sizeof(MIDI_out_caps));
  return (char *)MIDI_out_caps.szPname;
#endif
#ifdef OSX
  /*  OS X  */
  static char name[1024];

  CFStringRef pname;
  gDest = MIDIGetDestination(port);
  if(gDest != NULL){
    MIDIObjectGetStringProperty(gDest, kMIDIPropertyName, &pname);
    CFStringGetCString(pname, name, sizeof(name), 0);
    CFRelease(pname);
    return (char *)name;
  }
#endif

#ifdef LINUX
  ;  /*  not implemented yet.  */
  port = port;
#endif

  return NULL;

}


void midi_exit(int dummy)
{
  dummy = dummy;

  puts("");
  close_midi_out_all();
  puts("");
  stop_counter();
  puts("");
  close_counter();
  puts("");
  close_midi_in_all();
  puts("");
}


void close_midi_out_all(void)
{
  int i;


  if(midiout_init_called == OFF){  return; }

  for(i = 0; i < PORT_NUM_BUFSIZE; i++){
    if(out_port[i] != NOT_PORT_NO){
      close_midi_out(out_port[i]);
    }
  }
}


int select_midi_in(void)
{
  char buf[1024];
  int num;
  int i;
  int port;



#ifdef CYGWIN
  /*  MIDI IN foCXg悤ɂݒ  */
  num = midiInGetNumDevs();
#endif
#ifdef OSX
  /*  OS X  */
  num = MIDIGetNumberOfSources();
#endif
#ifdef LINUX
  i = i;
  num = 0;;
#endif

  if(num == 0){
    printf("No MIDI sources present\n");
    exit(EXIT_FAILURE);
  }

#ifdef CYGWIN
  for(i = 0; i < num; i++){
    printf("%2d: %s\n", i, get_midi_in_name(i));
  }
#endif
#ifdef OSX
  /*  OS X  */
  for(i = 0; i < num; i++){
    printf("%2d: %s\n", i, get_midi_in_name(i));
  }
#endif

  fgets(buf, sizeof(buf), stdin);
  if(sscanf(buf, "%d", &port) == 1){
    return port;
  }else{
    return -1;
  }

  return EXIT_SUCCESS;

}


char *get_midi_in_name(int port)
{
#ifdef  CYGWIN
  if(midiInGetDevCaps(port, &MIDI_in_caps, sizeof(MIDI_in_caps)) == MMSYSERR_NOERROR){
    return (char *)MIDI_in_caps.szPname;
  }else{
    return (char *)NULL;
  }
#endif

#ifdef OSX
  /*  OS X  */
  static char name[STRBUFLEN];
  CFStringRef pname;
  static char tmpname[STRBUFLEN];

  strcpy(name, "");
  gSrc = MIDIGetSource(port);
  if(gSrc != NULL){
    MIDIObjectGetStringProperty(gSrc, kMIDIPropertyName, &pname);
    CFStringGetCString(pname, tmpname, sizeof(tmpname), 0);
    strcat(name, tmpname);
    strcat(name, " ");
    CFRelease(pname);

#if 0
    MIDIObjectGetStringProperty(gSrc, kMIDIPropertyManufacturer, &pname);
    CFStringGetCString(pname, tmpname, sizeof(tmpname), 0);
    strcat(name, tmpname);
    strcat(name, " ");
    CFRelease(pname);
#endif

#if 0
    MIDIObjectGetStringProperty(gSrc, kMIDIPropertyModel, &pname);
    CFStringGetCString(pname, tmpname, sizeof(tmpname), 0);
    strcat(name, tmpname);
    CFRelease(pname);
#endif

    return (char *)name;
  }else{
    return (char *)NULL;
  }
#endif

#ifdef LINUX
  ;  /*  not implemented yet.  */
  port = port;
#endif

  return (char *)NULL;  /*  Dummy  */

}


int open_midi_in(int arg_in_port)
{
  int i;
  int in_port_idx;
  
  
  if(midiin_init_called == OFF){
    midiin_init_called = ON;
    for(i = 0; i < PORT_NUM_BUFSIZE; i++){
      in_port[i] = NOT_PORT_NO;
    }
  }
  
  for(in_port_idx = 0; in_port_idx < PORT_NUM_BUFSIZE; in_port_idx++){
    if(in_port[in_port_idx] == NOT_PORT_NO){
      in_port[in_port_idx] = arg_in_port;
      break;
    }
  }
  if(in_port_idx >= PORT_NUM_BUFSIZE){
    br_printf(6, "%s: %d: PORT_NUM_BUFSIZE  %d 傫čăRpCĂD\n", __FILE__, __LINE__,
	      PORT_NUM_BUFSIZE);
    return EXIT_FAILURE;
  }

  printf("MIDI In: Open %s... ", get_midi_in_name(in_port[in_port_idx]));


#ifdef CYGWIN
  /*  hwnd: bZ[W`EBhẼnh  */
  /*  CALLBACK_WINDOW  */
  if(midiInOpen(&MIDI_in_Handle, (UINT)in_port[in_port_idx], (DWORD)midi_in, (DWORD)NULL, CALLBACK_FUNCTION)
     == MMSYSERR_NOERROR){
    br_printf(5, "Ok!\n");
  }else{
    br_printf(2, "NG.\n");
    return EXIT_FAILURE;
  }
  
  printf("MIDI In: Start ");
  if(midiInStart(MIDI_in_Handle) == MMSYSERR_NOERROR){
    br_printf(5, "OK!\n");
  }
  else{
    br_printf(2, "NG.\n");
    close_midi_in(arg_in_port);
  }

  return EXIT_SUCCESS;

#endif

#ifdef OSX
  /*  OS X  */

  in_client = NULL;
  MIDIClientCreate(CFSTR(CLISTR), NULL, NULL, &in_client);
  
  inPort = NULL;
  MIDIInputPortCreate(in_client, CFSTR(INCLISTR), midi_in, NULL, &inPort);
  if((gSrc = MIDIGetSource(in_port[in_port_idx])) != NULL){
    br_printf(5, "Ok!\n");
  }else{
    br_printf(2, "NG.\n");
    return EXIT_FAILURE;
  }
  
  printf("MIDI In: Start ");
  
  MIDIPortConnectSource(inPort, gSrc, NULL);  /*  koko OSStatus ݂āCG[ȂƂȂȂ  */
  br_printf(5, "OK!\n");

  ticks_sec = AudioGetHostClockFrequency();

  return EXIT_SUCCESS;
#endif

#ifdef LINUX
  ;  /*  not implemented yet.  */
  return EXIT_SUCCESS;
#endif


}


int close_midi_in(int arg_in_port)
{
  int i;

#ifdef OSX
/*   CFStringRef pname; */
/*   char name[1024]; */
#endif

  if(midiin_init_called == OFF){
    return  EXIT_SUCCESS;
  }

/* close_midi_out() ł́C All Note-off  All Sound Off 𑗂  */
  for(i = 0; i < PORT_NUM_BUFSIZE; i++){
    if(in_port[i] == arg_in_port){
      in_port[i] = NOT_PORT_NO;
    }
  }

  for(i = 0; i < PORT_NUM_BUFSIZE; i++){
    if(in_port[i] != NOT_PORT_NO){  break; }
  }
  if(i == PORT_NUM_BUFSIZE){
    midiin_init_called = OFF;
  }

#ifdef ALGO1
    pre_time = 0;
#endif

    now_time = 0;
    int_tick = 0;
    counter = 0;
    pause_tick = 0;
    pause_time = 0;


    br_printf(-1, "\n");

#ifdef CYGWIN
  /*  MIDI IN foCXgȈ  */
  printf("MIDI In: Reset %s... ", get_midi_in_name(arg_in_port));
  if(midiInStop(MIDI_in_Handle) == MMSYSERR_NOERROR){
    br_printf(5, "Ok!\n");
  }
  else{
    br_printf(2, "NG.\n");
  }


  printf("MIDI In: Close %s... ", get_midi_in_name(arg_in_port));
  if(midiInClose(MIDI_in_Handle) == MMSYSERR_NOERROR){
    br_printf(5, "Ok!\n");
    return EXIT_SUCCESS;
  }else{
    br_printf(2, "NG.\n");
    return EXIT_FAILURE;
  }
#endif

#ifdef OSX
  /*  OS X  */
  printf("MIDI In: Reset %s... ", get_midi_in_name(arg_in_port));
 if((gSrc = MIDIGetSource(arg_in_port)) != NULL){
   MIDIPortConnectSource(inPort, gSrc, NULL);  /*  iranai?  */
   MIDIPortDisconnectSource(inPort, gSrc);
   br_printf(5, "Ok!\n");
 }else{
    br_printf(2, "NG.\n");
 }

 printf("MIDI In: Close %s... ", get_midi_in_name(arg_in_port));

 MIDIClientDispose(in_client );
 br_printf(5, "Ok!\n");  /*  koko  OSStatus ݂āCG[`FbNȂƂ˂D  */
 return EXIT_SUCCESS;
#endif

#ifdef LINUX
  return EXIT_FAILURE;
#endif

  return EXIT_SUCCESS;

}


void close_midi_in_all(void)
{
  int i;

  if(midiin_init_called == OFF){  return; }

  for(i = 0; i < PORT_NUM_BUFSIZE; i++){
    if(in_port[i] != NOT_PORT_NO){
      close_midi_in(in_port[i]);
    }
  }
}





#ifdef  CYGWIN
void CALLBACK midi_in(HMIDIIN MIDI_in_Handle, UINT Msg, DWORD Instance, DWORD Para1, DWORD Para2)
#endif

#ifdef OSX
void midi_in(const MIDIPacketList *pktlist, void *refCon, void *connRefCon)
#endif

#ifdef LINUX
void midi_in(int intarg)
#endif
{
#define VALNUM  2

  static double timestamp;
  static int stat;
  static int val[VALNUM];
  static EL *e_srch;


#ifdef CYGWIN
  /*  Warning ΍  */
  MIDI_in_Handle = MIDI_in_Handle;
  Msg = Msg;
  Instance = Instance;
  /*  Warning ΍􂱂܂  */

#if 0
  printf("Msg: %ld, %02x %02x %02x %02x, Para1: %02x %02x %02x %02x\n",
	 Para2,
	 (UINT)(Msg & 0xff),
	 (UINT)((Msg >>  8) & 0xff),
	 (UINT)((Msg >> 16) & 0xff),
	 (UINT)((Msg >> 24) & 0xff), 
	 (UINT)(Para1 & 0xff),
	 (UINT)((Para1 >>  8) & 0xff),
	 (UINT)((Para1 >> 16) & 0xff),
	 (UINT)((Para1 >> 24) & 0xff)
	   );
#endif
  if(midi_in_through == ON){
/*     midi_out(0, 0x90, now_on_note, 0, NULL); */
/*     ValPack = 0; */
/*     ValPack += stat; */
/*     ValPack += val1 * 256; */
/*     ValPack += val2 * 256 * 256; */
    midiOutShortMsg(MIDI_out_Handle, Para1);
  }

  timestamp = Para2;   /*  1000 tick / second  */
  stat = (int)(Para1 & 0xff);
  val[0] = (int)((Para1 >>  8) & 0xff);
  val[1] = (int)((Para1 >> 16) & 0xff);

#endif

#ifdef OSX
  /*  unsigned int j;  */
  /*  int i;  */

  /*  Warning ΍  */
  refCon = refCon;
  connRefCon = connRefCon;
  /*  Warning ΍  */

  in_packet = (MIDIPacket *)pktlist->packet;	// remove const (!)

/*   for (j = 0; j < pktlist->numPackets; ++j) { */
    timestamp = in_packet->timeStamp / ticks_sec;
    stat = in_packet->data[0];
    val[0] = in_packet->data[1];
    val[1] = in_packet->data[2];
    in_packet = MIDIPacketNext(in_packet);
/*   } */

#if 0
  static UInt64 pretime;

  in_packet = (MIDIPacket *)pktlist->packet;	// remove const (!)

  printf("%lld\n", AudioGetHostClockFrequency());  /*  ticks / second  */

  for (j = 0; j < pktlist->numPackets; ++j) {
    printf("%llf: ", in_packet->timeStamp / ((long double)AudioGetHostClockFrequency() / 1000.0));
    printf("%llf: ", (long double)(in_packet->timeStamp - pretime) /
	   ((long double)AudioGetHostClockFrequency() / 1000.0) );  /*  ̗p  */
    pretime = in_packet->timeStamp;
    for (i = 0; i < in_packet->length; ++i) {
      printf("%02x ", in_packet->data[i]);
    }
    printf("\n");
    in_packet = MIDIPacketNext(in_packet);
  }
#endif

#endif
#ifdef LINUX
  intarg = intarg;
#endif



  /*------  ------*/
  switch(stat){
  case  0xf8: /*  ^C~ONbNCC^[o^C}荞݂̑Ɏg  */
/*   case  0xfe: */
/* 	br_printf(5, "%6.1f msec: %02X %02X %02X\n",  timestamp, stat, val[0], val[1]); */
    f8counter++;
    if( (f8counter % 10) == 0){
      if(pctrl.displevel >= 2){
	br_printf(5, "%6.1f msec: %02X %02X %02X\n",  timestamp, stat, val[0], val[1]);
      }
      if(RTgpr_mode == ON){
	RTgpr_body(0);
/* 	should_re_draw = ON; */
      }
      if(should_re_draw == ON){
/* 	br_printf(6, "midiin re_draw\n"); */
	re_draw();
	glutPostRedisplay();
	should_re_draw = OFF;
      }
    }
    return;
#ifdef _4RU_H
  case  0xb0:
  case  0xb1:
/*     if(midiin_scaling == ON){ */
    if(val[0] == 0x40){
      NOTE_list_free(note_top);
      EL_list_free(e_top);
      pre_alloc();
      re_draw();
      glutPostRedisplay();
    }else if( (val[0] == 0x07) ||
	      ( ((seq_button == START) &&
		 (
		  ((0x0b <= val[0]) && (val[0] <= 0x13)) ||
		  ((0x47 <= val[0]) && (val[0] <= 0x4e))
		  ) ) ) ){
      if(val[1] != 64){
	ppqbeat = (128 - val[1]) * 2;
	should_re_draw = ON;
      }
    }
    return;

  case  0xfa: /*  VL[ [START] {^  */
    seq_button = START;
    should_re_draw = ON;
    re_draw();
    return;

  case  0xfc: /*  VL[ [STOP] {^  */
/*     if(midiin_scaling == ON){ */
/*       midiin_scaling = OFF; */
/*     }else{ */
/*       midiin_scaling = ON; */
/*     } */
    seq_button = STOP;
    should_re_draw = ON;
    re_draw();

    return;
#endif
  }

  if(e_top != NULL){
    if(e_bot != NULL){
      if(e_bot->timestamp >= 0.0){
	if(e_bot->next != NULL){
	  e_bot = e_bot->next;
	}
      }
    }

    if(e_bot != NULL){
      e_bot->timestamp = timestamp;
      e_bot->abs_time = timestamp;
      e_bot->stat = stat;
      e_bot->val1 = val[0];
      e_bot->val2 = val[1];
      set_event_str(&e_bot);

      if(e_bot->ident == NOTE){
	if(e_bot->val2 == 0){  /*  note off  */
	  midinote_in = OFF;
	  should_re_draw = ON;
	  /*  calc duration time */
	  e_srch = e_bot->pre;
	  while(1){
	    if(e_srch == NULL){  break;  }
	    if( (e_srch->ident == NOTE) && (e_srch->val1 == e_bot->val1) ){
	      e_srch->dur_time = e_bot->abs_time - e_srch->abs_time;
	      for(dec_dur_i = 0; DECIDE_DUR_NUM; dec_dur_i++){
		if(decide_dur[dec_dur_i] == NULL){
		  decide_dur[dec_dur_i] = e_srch;
		  break;
		}
	      }
	      break;
	    }
	    e_srch = e_srch->pre;
	  }
	}else{  /*  note on  */
	  /*  calc IOI */
	  midinote_in = ON;
	  should_re_draw = ON;
	  e_srch = e_bot;
	  while(1){
	    if(e_srch == NULL){  break; }
	    if( (e_srch->ident == NOTE) && (e_srch->val2 != 0) ){
	      e_srch->IOI_time = e_bot->abs_time - e_srch->abs_time;
	      break;
	    }
	    e_srch = e_srch->pre;
	  }
	}
      }

      if(pctrl.displevel > 0){
	br_printf(5, "%6.1f msec: %02X %02X %02X: %s\n",
		  e_bot->timestamp, e_bot->stat, e_bot->val1, e_bot->val2, e_bot->str);
      }
      
    }else{  /*  e_bot == NULL  */
      disp_errline(__FILE__, __LINE__, NULL, 0, "MIDI in buffer is full!.");
      br_printf(-1, "NOTEfile.h  MIDIIN_PRE_ALLOC  ̒l %d 傫ĂD\n", MIDIIN_PRE_ALLOC);
    }

    midiin_called = ON;
    
/*     if(midiin_mode == ON){ */
/*       br_printf(5, "GPR\n"); */
/*       RTgpr_body(0); */
/*     } */
  }
}
